function loadListboxByAssignment(arrayList,containerId, isAssigned)
{
   var $selectTag = $('#'+containerId+' select');
   // if zero or more than one select tag, there is a problem
   if($selectTag.length !== 1) return; // RAPTOR-2399

   var selectData = [];
   var groupData = [];
   var showGroups = $selectTag[0].getAttribute('showgroups');
   for(var i = 0, len = arrayList.length; i < len; i++)
   {

      if(showGroups=="true" && "isGroup" in arrayList[i])
      {
         if (arrayList[i].isGroup)
         {
            if (groupData.length > 1)
            {
               	selectData.push(groupData);
                selectData.push("</optgroup>");
            }
            groupData = [];
            groupData.push("<optgroup label='" + arrayList[i].label + "'>");
         }
      }

      if("isAssigned" in arrayList[i])
      {
         if(arrayList[i].isAssigned === isAssigned)
         {
        	 if (containerId == "assignedAnalystsContainer" || containerId == "unassignedAnalystsContainer" )
        	 {
            	 if(arrayList[i].isDuplicated != undefined && arrayList[i].isDuplicated === true)
            	 {
            		 var strOption = "<option  title='"+arrayList[i].label+"'" + " value='"+i+"' disabled>"+arrayList[i].label+"</option>";
            	 } else {
            		 var strOption = "<option  title='"+arrayList[i].label+"'" + " value='"+i+"'>"+arrayList[i].label+"</option>";
            	 }
        	 } else {
        		 var strOption = "<option  title='"+arrayList[i].label+"'" + " value='"+i+"'>"+arrayList[i].label+"</option>";
        	 }

            if (groupData.length > 0)
               groupData.push(strOption);
            else
               selectData.push(strOption);
         }
      }
   }
   if (groupData.length > 1)
   {
      	selectData.push(groupData);
        selectData.push("</optgroup>");
   }
   $selectTag.html(selectData.join(''));
}

function loadListbox(containerId, valueArray,textArray)
{
   var $selectTag = $('#'+containerId+' select');
   // if zero or more than one select tag, there is a problem
   if($selectTag.length !== 1) return; // RAPTOR-2399

   var selectData = [];
   for(var i = 0, len = valueArray.length; i < len; i++)
   {
      selectData.push("<option  title='"+valueArray[i].label+"'" + " value='"+valueArray[i]+"'>"+textArray[i]+"</option>");
   }
   $selectTag.html(selectData.join(''));
}

function moveSelectedOptionsAnalyst(srcLbx,tgtLbx,isAssigned,list)
{
   if(srcLbx.selectedIndex === -1) return;
   var keyFieldList = [];
   var isDuped = false;
   for(var i = srcLbx.options.length-1; i >= 0; i--)
   {
//	  alert ("0: " + list[parseInt(srcLbx.options[i].value)].label + list[parseInt(srcLbx.options[i].value)].isDuplicated + list[parseInt(srcLbx.options[i].value)].isAssigned);
      if(srcLbx.options[i].selected)
      {
      	 var al =  list[parseInt(srcLbx.options[i].value)];
		 var keyField = al.tenantId + ":" + al.keyField;
		 if (keyFieldList.indexOf(keyField)=== -1)
		 {
			 keyFieldList.push(keyField);
		 } else {
			 isDuped = true;
			 srcLbx.selectedIndex = -1;
			 keyFieldList = [];

			if (al.tenantLabel && al.tenantLabel != "")
			{
			 alert($i18n("fcm.sq.strategy.js.alert2.2.fmt.txt", [al.tenantLabel, al.keyField]));
			}
			else
			{
			 alert($i18n("fcm.sq.strategy.js.alert2.1.fmt.txt", [al.keyField]));
			}
			 return;
		 }
      }
   }

   if (!isDuped)
   {
	   for(var i = srcLbx.options.length-1; i >= 0; i--)
	   {
	      if(srcLbx.options[i].selected)
	      {
	         // change assigned status of user
	         updateItemAssignment(list,srcLbx.options[i].value,isAssigned);
	      }
	   }

	   var keyFieldList = [];
	   for(var i = 0, len = list.length; i < len; i++)
	   {
//		   alert (list[i].label + list[i].isDuplicated + list[i].isAssigned);
	       var al = list[i];
	       if(al.isAssigned)
	       {
 		 	   var keyField = al.tenantId + ":" + al.keyField;
	    	   if (keyFieldList.indexOf(keyField) == -1)
	    	   {
	    		   keyFieldList.push(keyField);
	    	   } else {
	    		   srcLbx.selectedIndex = -1;
				   keyFieldList = [];
					if (al.tenantLabel && al.tenantLabel != "")
				    {
				   		alert($i18n("fcm.sq.strategy.js.alert3.2.fmt.txt",[al.tenantLabel, al.keyField]));
				   	}
				   	else
				   	{
				   		alert($i18n("fcm.sq.strategy.js.alert3.1.fmt.txt",[al.keyField]));
				   	}
				   return;
	    	   }
	       }
	   }

	   for(var j = 0, len = list.length; j < len; j++)
	   {
	       var al = list[j];
	       if(!al.isAssigned)
	       {
	 		   var keyField = al.tenantId + ":" + al.keyField;
	           if(keyFieldList.indexOf(keyField) != -1)
	           {
	        	   list[j].isDuplicated = true;
	        	   list[j].label = "* " + al.name;
	           } else {
	        	   list[j].isDuplicated = false;
	        	   list[j].label = al.name;
	           }
	       }
	   }
	   keyFieldList = [];
	   loadListboxByAssignment(list,srcLbx.parentNode.id,!isAssigned);
	   loadListboxByAssignment(list,tgtLbx.parentNode.id,isAssigned);
   }
}

function moveSelectedOptions(srcLbx,tgtLbx,isAssigned,list)
{
   if(srcLbx.selectedIndex === -1) return;

   for(var i = srcLbx.options.length-1; i >= 0; i--)
   {
      if(srcLbx.options[i].selected)
      {
         // change assigned status of user
         updateItemAssignment(list,srcLbx.options[i].value,isAssigned);
      }
   }

   loadListboxByAssignment(list,srcLbx.parentNode.id,!isAssigned);
   loadListboxByAssignment(list,tgtLbx.parentNode.id,isAssigned);

}
function moveAllOptions(srcLbx,tgtLbx,isAssigned, list)
{
	for(var i = srcLbx.options.length-1; i >= 0; i--)
	{
		// change assigned status of user
		updateItemAssignment(list,srcLbx.options[i].value,isAssigned);
	}

	loadListboxByAssignment(list,srcLbx.parentNode.id,!isAssigned);
	loadListboxByAssignment(list,tgtLbx.parentNode.id,isAssigned);
}
function updateItemAssignment(list, idx, isAssigned)
{
   list[parseInt(idx)].isAssigned = isAssigned;
   return list[parseInt(idx)];
}
var _menuName = null;
var _hideElemList = null;
function showDropDownMenu(menuName,hideElemList)
{
	if(!menuName) return;

	// make sure anchor clicked is not disabled
	if(getElement(menuName+"Anchor").disabled) return;

  	hideDropDownMenu(_menuName, _hideElemList);

   var menu = document.getElementById(menuName+'Div');
   var menuItem = document.getElementById(menuName+'Anchor');

   //hide elements that may get in the way
   for(var i = 0; hideElemList && i < hideElemList.length; i++)
   {
      hideElemList[i].style.visibility="hidden";
   }

   menuItem.className="menuItemButtonClicked";

   menu.style.top = getBottomPosition(menuItem) + "px";
   menu.style.left = getLeftPosition(menuItem) + "px";

   menu.style.visibility="visible";

   _menuName = menuName;
   _hideElemList = hideElemList;

}

function hideDropDownMenu(menuName,showElemList)
{
	if(!menuName) return;

   var menu = document.getElementById(menuName+'Div');
   var menuItem = document.getElementById(menuName+'Anchor');

   menuItem.className="menuItemButton";
   menu.style.visibility="hidden";

   //show elements that were in the way
   for(var i = 0; showElemList && i < showElemList.length; i++)
   {
      showElemList[i].style.visibility="visible";
   }

   _menuName = null;
   _hideElemList = null;

}

function dismissPopup( menuName )
{
	if ($("#"+menuName+"Div").css("visibility") == "visible")
		$("#"+menuName+"Close").click();
}

function showDescription(anchor, srcArrayListName,lstbx)
{
   if(lstbx.selectedIndex == -1) return;

   var list = eval(srcArrayListName);
   var desc = document.getElementById('descriptionWindow');
   var descText = document.getElementById('descriptionWindowTextArea');
   descText.value = "";

   if(!desc.childNodes.length <= 1)
      desc.appendChild(descText);

   var optNum = lstbx.options.length;
   var entryCount = 0;
   var descTextData = [];
   for(var i = 0; i < optNum; i++)
   {
      if(lstbx.options[i].selected)
      {
         var indx = lstbx.options[i].value;
         if( entryCount > 0 )
        	 descTextData.push("<br/>"+(list[indx].label)+":<br/>"+(list[indx].text)+"<br/>");
         else
        	 descTextData.push((list[indx].label)+":<br/>"+(list[indx].text)+"<br/>");

         entryCount++;
      }
   }
   $(descText).append(descTextData.join(''));
	displayDescription(anchor);
//   descText.style.display="block";
//   var refObj = anchor;
//   var imgs = anchor.getElementsByTagName("IMG");
//   if(imgs && imgs.length == 1)
//      refObj = imgs[0];
//
//   desc.style.left = getRightPosition(refObj);
//   desc.style.top = getTopPosition(refObj);
//   desc.style.visibility="visible";

}
var _anchor = null;
function displayDescription(anchor)
{
	if(!anchor) return;
	_anchor = anchor;

   var desc = document.getElementById('descriptionWindow');
   var descText = document.getElementById('descriptionWindowTextArea');

   var refObj = anchor;
   var spans = anchor.getElementsByTagName("SPAN");
   if(spans && spans.length == 1)
      refObj = spans[0];

	descText.style.display="block";

   desc.style.left = getRightPosition(refObj) + "px";
   desc.style.top = getTopPosition(refObj) + "px";
   desc.style.visibility="visible";

}

function hideDescription()
{
   var desc = document.getElementById('descriptionWindow');
   var descText = document.getElementById('descriptionWindowTextArea');
   descText.value = "";

   descText.style.display="none";
   desc.style.visibility="hidden";
   _anchor = null;
}

window.previousOnResize = window.onresize;
  $("body").scroll(function(){showDropDownMenu(_menuName,_hideElemList);displayDescription(_anchor)});
if(window.previousOnResize != null)
{
	window.onresize = new Function("window.previousOnResize();showDropDownMenu(_menuName,_hideElemList);displayDescription(_anchor);");
}
else
{
	window.onresize = function(){showDropDownMenu(_menuName,_hideElemList);displayDescription(_anchor);};
	document.body.onscroll = function(){showDropDownMenu(_menuName,_hideElemList);displayDescription(_anchor);};
}
