sap.ui.jsfragment("sas.fscf.views.fragments.PrioritizeRulesDialog", {

	_oData: null,
	_currentRuleType: null,
	_oDirty: null,
	_oDialog:null,

	isDirty: function() {
		return this._oDirty["Variable"] || this._oDirty["Authorization"] || this._oDirty["Queue"];
	},

	setDirty: function(bDirty) {
    	if (!this._currentRuleType) {
    		this._currentRuleType = "Authorization";
    	}
    	if (!this._oDirty) {
    		this._oDirty = {"Variable":false, "Authorization":false, "Queue":false};
    	}
		this._oDirty[this._currentRuleType] = bDirty;
		sap.ui.getCore().byId(sap.ui.getCore().byId("prioritizeRulesDialog").getLeftButton()).setEnabled(this.isDirty());

		this.validateOrder(this._currentRuleType);
	},

	isDirtyForRuleType: function(ruleType) {
		return this._oDirty[ruleType];
	},

	createContent: function(oController) {
		jQuery.sap.require("sas.hc.m.Dialog");
		jQuery.sap.require("sas.hc.m.MessageDialog");
        jQuery.sap.require("sas.hc.m.FlexBox");
        jQuery.sap.require("sas.hc.m.FlexItemData");
        jQuery.sap.require("sas.hc.m.HBox");
        jQuery.sap.require("sas.hc.m.VBox");
        jQuery.sap.require("sas.hc.m.SegmentedButton");
        jQuery.sap.require("sas.hc.m.Button");
        jQuery.sap.require("sas.hc.ui.layout.Splitter");
        jQuery.sap.require("sas.hc.ui.layout.SplitterLayoutData");
        jQuery.sap.require("sas.hc.m.Label");
        jQuery.sap.require("sas.hc.m.List");
        jQuery.sap.require("sas.hc.m.StandardListItem");
        jQuery.sap.require("sap.ui.model.json.JSONModel");
        jQuery.sap.require("sas.hc.ui.commons.dualselector.DualSelector");

		var _this = this;
		// Must be in "Variable", "Authorization", "Queue" order
		_this._oData = {"Variable":{}, "Authorization":{}, "Queue":{}};
		_this._oDirty = {"Variable":false, "Authorization":false, "Queue":false};

        var oSB1 = new sas.hc.m.Button({
            id: _this.sId + 'VariableButton',
            text: sas.fscf.rb.getText('rules.rulesPage.rules.type.variable.txt'),
            press: function () {
            	_this.switchToRuleType("Variable", oDialog, oExtraLabel, oExtraList, oDualSelector);
            },
            width:'33.3%'
        });
        var oSB2 = new sas.hc.m.Button({
            id: _this.sId + 'AuthorizationButton',
            text: sas.fscf.rb.getText('rules.rulesPage.rules.type.authorization.txt'),
            press: function () {
            	_this.switchToRuleType("Authorization", oDialog, oExtraLabel, oExtraList, oDualSelector);
            },
            width:'33.4%'
        });
        var oSB3 = new sas.hc.m.Button({
            id: _this.sId + 'QueueButton',
            text: sas.fscf.rb.getText('rules.rulesPage.rules.type.queue.txt'),
            press: function () {
            	_this.switchToRuleType("Queue", oDialog, oExtraLabel, oExtraList, oDualSelector);
            },
            width:'33.3%'
        });

        var oSegButton = new sas.hc.m.SegmentedButton({
            id: _this.sId + 'SegmentedButton',
            width:'100%',
            buttons: [
                      oSB1,
                      oSB2,
                      oSB3
            ],
            selectedButton: oSB2,
            layoutData: new sas.hc.m.FlexItemData({growFactor:1})
        });

        var oExtraUpEndButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraUpEndButton',
            icon: sas.icons.HC.ARROWSMALLUPEND,
            enabled: false,
            press: function () {
        		_this.moveExtraListItems(oExtraList, oExtraList.getSelectedItems(), -100, oExtraUpEndButton, oExtraUpButton, oExtraDownButton, oExtraDownEndButton);
            },
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraUpButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraUpButton',
            icon: sas.icons.HC.ARROWSMALLUP,
            enabled: false,
            press: function () {
        		_this.moveExtraListItems(oExtraList, oExtraList.getSelectedItems(), -1, oExtraUpEndButton, oExtraUpButton, oExtraDownButton, oExtraDownEndButton);
            },
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraDownButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraDownButton',
            icon: sas.icons.HC.ARROWSMALLDOWN,
            enabled: false,
            press: function () {
        		_this.moveExtraListItems(oExtraList, oExtraList.getSelectedItems(), 1, oExtraUpEndButton, oExtraUpButton, oExtraDownButton, oExtraDownEndButton);
            },
            layoutData: new sas.hc.m.FlexItemData({styleClass:"cfTriSelectorDownButtonFI"})
        });

        var oExtraDownEndButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraDownEndButton',
            icon: sas.icons.HC.ARROWSMALLDOWNEND,
            enabled: false,
            press: function () {
        		_this.moveExtraListItems(oExtraList, oExtraList.getSelectedItems(), 100, oExtraUpEndButton, oExtraUpButton, oExtraDownButton, oExtraDownEndButton);
            },
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraUpDownVBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'ExtraUpDownVBox',
            direction: "Column",
            justifyContent: "Center",
            height: "450px",
            items: [
                    oExtraUpEndButton,
                    oExtraUpButton,
                    oExtraDownButton,
                    oExtraDownEndButton
            ],
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraLabel = new sas.hc.m.Label({
            id: _this.sId + 'ExtraLabel',
            text: sas.fscf.rb.getText('rules.rulesPage.rules.order.pre.txt'),
            labelFor: _this.sId + 'ExtraList',
            layoutData: new sas.hc.m.FlexItemData({styleClass:"cfTriSelectorLabelFI"})
        });

        var oExtraList = new sas.hc.m.List({
            id: _this.sId + 'ExtraList',
            mode: sap.m.ListMode.MultiSelect,
            layoutData: new sas.hc.m.FlexItemData({growFactor:1,styleClass:"cfTriSelectorListFI"})
        });
        oExtraList.enableDesktopBehavior(true);

        var oExtraListVBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'ExtraListVBox',
            direction: "Column",
            width: "calc(100% - 1.5rem)",
            height: "450px",
            items: [
                    oExtraLabel,
                    oExtraList
            ],
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraLeftRightButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraLeftRightButton',
            icon: sas.icons.HC.ARROWLEFTADDDUALSELECTOR,
            enabled: false,
            press: function () {
            	if (oExtraLeftRightButton.getIcon() == sas.icons.HC.ARROWLEFTADDDUALSELECTOR) {
            		_this.moveToExtraList(oExtraList, oDualSelector, oDualSelector.getAvailableList().getSelectedItems(), oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel);
            	} else {
            		_this.moveFromExtraList(oExtraList, oDualSelector, oExtraList.getSelectedItems(), oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel);
            	}
            },
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraLeftRightAllButton = new sas.hc.m.Button({
            id: _this.sId + 'ExtraLeftRightAllButton',
            icon: sas.icons.HC.ARROWLEFTADDALLDUALSELECTOR,
            press: function () {
            	if (oExtraLeftRightButton.getIcon() == sas.icons.HC.ARROWLEFTADDDUALSELECTOR) {
            		_this.moveToExtraList(oExtraList, oDualSelector, oDualSelector.getAvailableList().getItems(), oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel);
            	} else {
            		_this.moveFromExtraList(oExtraList, oDualSelector, oExtraList.getItems(), oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel);
            	}
            },
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oExtraLeftRightVBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'ExtraLeftRightVBox',
            direction: "Column",
            justifyContent: "Center",
            height: "450px",
            items: [
                    oExtraLeftRightButton,
                    oExtraLeftRightAllButton
            ],
            layoutData: new sas.hc.m.FlexItemData({})
        });

        var oDualSelector = new sas.hc.ui.commons.dualselector.DualSelector({
            id: _this.sId + "DualSelector",
            contextPath: "/items",
            labelField: "_displayName",
            descriptionField: "_displayDescription",
            showSearch: true,
            showUndo: false,
            sourceLabel: sas.fscf.rb.getText('rules.rulesPage.rules.order.main.txt'),
            targetLabel: sas.fscf.rb.getText('rules.rulesPage.rules.order.post.txt')
        });

  	    oDualSelector.setModel(new sap.ui.model.json.JSONModel()); // blank initially
	    oDualSelector.attachSelectedItemsReordered(function (e) {
			_this.setDirty(true);
	    });
	    oDualSelector.attachDualSelectorCreationComplete(function (e) {
		    sap.ui.getCore().byId(oDualSelector.sId + "-moveManager-moveLayout-1-addButton").attachPress(function (e) {
				_this.setDirty(true);
		    });
		    sap.ui.getCore().byId(oDualSelector.sId + "-moveManager-moveLayout-1-addAllButton").attachPress(function (e) {
				_this.setDirty(true);
		    });
		    sap.ui.getCore().byId(oDualSelector.sId + "-moveManager-moveLayout-1-removeButton").attachPress(function (e) {
				_this.setDirty(true);
		    });
		    sap.ui.getCore().byId(oDualSelector.sId + "-moveManager-moveLayout-1-removeAllButton").attachPress(function (e) {
				_this.setDirty(true);
		    });
		    oDualSelector.getAvailableList().attachSelectionChange(function (e) {
	    		oExtraList.removeSelections();
		    	oExtraLeftRightButton.setEnabled(oDualSelector.getAvailableList().getSelectedItems().length > 0);
		    	oExtraLeftRightButton.setIcon(sas.icons.HC.ARROWLEFTADDDUALSELECTOR);
		    	oExtraLeftRightAllButton.setIcon(sas.icons.HC.ARROWLEFTADDALLDUALSELECTOR);
		    });
		    oDualSelector.getTargetList().attachSelectionChange(function (e) {
	    		oExtraList.removeSelections();
		    	oExtraLeftRightButton.setIcon(sas.icons.HC.ARROWLEFTADDDUALSELECTOR);
		    	oExtraLeftRightAllButton.setIcon(sas.icons.HC.ARROWLEFTADDALLDUALSELECTOR);
		    });
	    });
	    oExtraList.attachSelectionChange(function (e) {
	    	oDualSelector.getAvailableList().removeSelections();
	    	oDualSelector.getTargetList().removeSelections();
	    	var bSelectionAndNotTop = oExtraList.getSelectedItems().length > 0 && oExtraList.indexOfItem(oExtraList.getSelectedItems()[0]) != 0;
	    	oExtraUpEndButton.setEnabled(bSelectionAndNotTop);
	    	oExtraUpButton.setEnabled(bSelectionAndNotTop);
	    	var bSelectionAndNotBottom = oExtraList.getSelectedItems().length > 0 && oExtraList.indexOfItem(oExtraList.getSelectedItems()[oExtraList.getSelectedItems().length - 1]) != oExtraList.getItems().length - 1;
	    	oExtraDownButton.setEnabled(bSelectionAndNotBottom);
	    	oExtraDownEndButton.setEnabled(bSelectionAndNotBottom);
	    	oExtraLeftRightButton.setEnabled(oExtraList.getSelectedItems().length > 0);
	    	if (oExtraList.getSelectedItems().length > 0) {
		    	oExtraLeftRightButton.setIcon(sas.icons.HC.ARROWRIGHTADDDUALSELECTOR);
		    	oExtraLeftRightAllButton.setIcon(sas.icons.HC.ARROWRIGHTADDALLDUALSELECTOR);
	    	}
	    });

        var oDualSelectorVBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'DualSelectorVBox',
            direction: "Column",
            width: "calc(100% - 25px)",
            height: "450px",
            items: [
                    oDualSelector
            ],
        	layoutData: new sas.hc.m.FlexItemData({})
        });

        var oSplitter1LayoutData1 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
            size: "31%"
        });
        var oSplitter1LayoutData2 = new sas.hc.ui.layout.SplitterLayoutData({
        	resizable: true,
        	size: "auto"
        });

        var oExtraSelectorHBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'ExtraSelectorHBox',
            direction: "Row",
            width: "100%",
            height: "450px",
            items: [
                    oExtraUpDownVBox,
                    oExtraListVBox
            ],
        	layoutData: oSplitter1LayoutData1
        });

        var oDualSelectorHBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'DualSelectorHBox',
            direction: "Row",
            width: "100%",
            height: "450px",
            items: [
                    oExtraLeftRightVBox,
                    oDualSelectorVBox
			],
        	layoutData: oSplitter1LayoutData2
        });

        var oSplitter1 = new sas.hc.ui.layout.Splitter({
            id: _this.sId + 'Splitter1',
            contentAreas: [oExtraSelectorHBox, oDualSelectorHBox],
            width: "100%",
            height: "450px",
            layoutData: new sas.hc.m.FlexItemData({growFactor:1,styleClass:"cfTriSelectorSplitterFI"})
        });

        var oFilterHBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'FilterHBox',
            direction: "Row",
            width: "80%",
            items: [
                    oSegButton
            ],
            layoutData: new sas.hc.m.FlexItemData({styleClass:"cfSegmentedButtonFI"})
        });

        var oTriSelectorHBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'TriSelectorHBox',
            direction: "Row",
            width: "100%",
            height: "100%",
            items: [
                    oSplitter1
            ],
        	layoutData: new sas.hc.m.FlexItemData({})
        });

        var oOuterVBox = new sas.hc.m.FlexBox({
            id: _this.sId + 'OuterVBox',
            direction: "Column",
            justifyContent: "Center",
            width: "100%",
            height: "100%",
            items: [
                    oFilterHBox,
                    oTriSelectorHBox
            ]
        });

         var oDialog = new sas.hc.m.Dialog({
        	id: "prioritizeRulesDialog",
        	title: sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.prioritizeRules.txt'),
    	    content: [
    	              oOuterVBox
    	    ],
    	    leftButton: new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('fcm.application.save.txt'),
    	    	enabled: false,
    	        press: function() {
    	        	this.setEnabled(false);
    	        	_this.save(oDialog, oExtraList, oDualSelector);
    	        }
    	    }),
    	    rightButton:  new sas.hc.m.Button({
    	    	text: sas.fscf.rb.getText('fcm.application.cancel.txt'),
    	        press: function() {
    	        	oDialog.close();
    	        }
    	    }),
    	    contentWidth: (window.innerWidth * 0.95) + "px"
        });

     	_this.switchToRuleType("Authorization", oDialog, oExtraLabel, oExtraList, oDualSelector);

		oDialog.attachAfterClose(function(oEvent) {
			_this._oData = null;
			_this._oDirty = null;
        	this.destroy();
        });

        _this._oDialog = oDialog;
        return oDialog;
    },

    moveExtraListItems: function(oExtraList, oExtraListItems, delta, oExtraUpEndButton, oExtraUpButton, oExtraDownButton, oExtraDownEndButton) {

		var index, temp, targetIndex;
		var selIndices = [];
		if (delta == 1 || delta == -1) {
			for (var i = (delta < 0) ? 0 : oExtraListItems.length - 1; (delta < 0) ? i < oExtraListItems.length : i >= 0; i += ((delta < 0) ? 1 : -1)) {
				index = oExtraList.indexOfItem(oExtraListItems[i] );
				temp = oExtraList.getModel().getData().items[index];
				targetIndex = index + delta;
				oExtraList.getModel().getData().items[index] = oExtraList.getModel().getData().items[targetIndex];
				oExtraList.getModel().getData().items[targetIndex] = temp;
				selIndices.push(targetIndex);
			}
		} else {
			temp = [];
			for (var i = oExtraListItems.length - 1; i >= 0; i--) {
				index = oExtraList.indexOfItem(oExtraListItems[i]);
				temp.unshift(oExtraList.getModel().getData().items.splice(index, 1));		//remove item from data
			}
			for (var i = (delta > 0) ? 0 : temp.length - 1; (delta > 0) ? i < temp.length : i >= 0; i += ((delta > 0) ? 1 : -1)) {
				if (delta > 0) {
					oExtraList.getModel().getData().items.push(temp[i][0]);
					selIndices.push(oExtraList.getModel().getData().items.length - 1);
				} else {
					oExtraList.getModel().getData().items.unshift(temp[i][0]);
					selIndices.unshift(i);
				}
			}
		}
		oExtraList.removeSelections();
		//re-bind
		oExtraList.getModel().setData(oExtraList.getModel().getData());
		//re-select
		for (var i = 0; i < selIndices.length; i++) {
			oExtraList.getItems()[selIndices[i]].setSelected(true);
		}
		oExtraUpButton.setEnabled(!oExtraList.getItems()[0].isSelected());
		oExtraUpEndButton.setEnabled(!oExtraList.getItems()[0].isSelected());
		oExtraDownButton.setEnabled(!oExtraList.getItems()[oExtraList.getItems().length - 1].isSelected());
		oExtraDownEndButton.setEnabled(!oExtraList.getItems()[oExtraList.getItems().length - 1].isSelected());
		this.setDirty(true);
	},

    moveToExtraList: function(oExtraList, oDualSelector, oDualSelectorItems, oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel) {

		var removedItem;
		for (var i = 0; i < oDualSelectorItems.length; i++) {
			for (var j = 0; j < oDualSelector.getModel().getData().items.length; j++) {
				if (oDualSelector.getModel().getData().items[j]._displayName == oDualSelectorItems[i].getTitle()) {
					if (oDualSelector.getModel().getData().items[j].isAvailable) {		//don't move any disabled ones
						removedItem = oDualSelector.getModel().getData().items.splice(j, 1);	//remove item from data
						oExtraList.getModel().getData().items.push(removedItem[0]);
						break;
					}
				}
			}
		}
		oDualSelector.getAvailableList().removeSelections();
		//re-bind
		oDualSelector.getModel().setData(oDualSelector.getModel().getData());
		oExtraList.getModel().setData(oExtraList.getModel().getData());
		if (oDualSelector.getAvailableList().getItems().length > 0) {
			oDualSelector.getAvailableList().getItems()[0].setSelected(true);
		} else {
	    	oExtraLeftRightButton.setIcon(sas.icons.HC.ARROWRIGHTADDDUALSELECTOR);
	    	oExtraLeftRightAllButton.setIcon(sas.icons.HC.ARROWRIGHTADDALLDUALSELECTOR);
		}
        setTimeout(function () {	// slight delay to give oExtraList time to re-render itself
    		oExtraList.getItems()[oExtraList.getItems().length - 1].focus();	// scroll the last item into view
        }, 200);
		oExtraList.fireSelectionChange();
        oExtraLabel.setText(sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.ruleOrderTypeWithCount.fmt.txt', [sas.fscf.rb.getText('rules.rulesPage.rules.order.pre.txt'), oExtraList.getItems().length]));
		this.setDirty(true);
    },

    moveFromExtraList: function(oExtraList, oDualSelector, oExtraListItems, oExtraLeftRightButton, oExtraLeftRightAllButton, oExtraLabel) {

		var dataIndex;
		var removedItem;
		for (var i = oExtraListItems.length - 1; i >= 0 ; i--) {
			dataIndex = parseInt(oExtraListItems[i].getBindingContextPath().split("/").pop());
			if (oExtraList.getModel().getData().items[dataIndex].isAvailable) {		//don't move any disabled ones
				removedItem = oExtraList.getModel().getData().items.splice(dataIndex, 1);		//remove item from data
				oDualSelector.addItemsToAvailableList([removedItem[0]]);
			}
		}
		oExtraList.removeSelections();
		//re-bind
		oExtraList.getModel().setData(oExtraList.getModel().getData());
		var bAnyAvailable = false;
		if (oExtraList.getItems().length > 0) {
			for (var i = 0; i < oExtraList.getItems().length; i++) {
				dataIndex = parseInt(oExtraList.getItems()[i].getBindingContextPath().split("/").pop());
				if (oExtraList.getModel().getData().items[dataIndex].isAvailable) {		//don't select any disabled ones
					oExtraList.getItems()[i].setSelected(true);
					bAnyAvailable = true;
			        setTimeout(function () {	// slight delay to give oExtraList time to re-render itself
			    		oExtraList.getItems()[i].focus();	// scroll the selected item into view
			        }, 200);
					break;
				}
			}
		}
		if (!bAnyAvailable) {
	    	oExtraLeftRightButton.setIcon(sas.icons.HC.ARROWLEFTADDDUALSELECTOR);
	    	oExtraLeftRightAllButton.setIcon(sas.icons.HC.ARROWLEFTADDALLDUALSELECTOR);
		}
		oExtraList.fireSelectionChange();
        oExtraLabel.setText(sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.ruleOrderTypeWithCount.fmt.txt', [sas.fscf.rb.getText('rules.rulesPage.rules.order.pre.txt'), oExtraList.getItems().length]));
		this.setDirty(true);
    },

    switchToRuleType: function(ruleType, oDialog, oExtraLabel, oExtraList, oDualSelector) {
    	var _this = this;
    	if (_this._currentRuleType == ruleType) {
    		return;
    	}

    	oDialog.setBusy(true);

    	// store the data of the current rule type
    	_this.storeDataForCurrentRuleType(oExtraList, oDualSelector);

    	// clear out extra list
		oExtraList.removeSelections();
		if (oExtraList.getModel()) {
			oExtraList.getModel().setData({});
		}
    	// clear out dual selector
    	oDualSelector.getTargetList().removeSelections();
    	oDualSelector.getAvailableList().removeSelections();
  	    oDualSelector.getModel().setData({});

    	_this._currentRuleType = ruleType;

    	// load the data of the new rule type
	    if (_this._oData[ruleType].Pre) {
	    	oExtraList.getModel().setData(_this._oData[ruleType].Pre);
		    oExtraLabel.setText(sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.ruleOrderTypeWithCount.fmt.txt', [sas.fscf.rb.getText('rules.rulesPage.rules.order.pre.txt'), oExtraList.getItems().length]));
	    	oDualSelector.getModel().setData(_this._oData[ruleType].MainPost);
	    	oDialog.setBusy(false);
	    } else {
	    	var fields = "id,baseRuleId,revision,name,state,transactionTypeDisplayName,transactionTypeAcronym,executionOrderType,executionOrderPriority,ruleTypeName,strongRuleDependencies";
			sas.ajax({url:"rest/businessunits/" + sas.fscf.getCurrentPageView().getBUId() + "/rules?filter=(state==\'Coding\' or state==\'Testing\' or state==\'Production\')  and ruleTypeName==\'" + ruleType + "\'&fields=" + fields, type: "GET", headers:sas.fscf.getAjaxHeaders()})
		  	  .done(function(oData){
			  	_this.annotateData(oData.items);


		  		// sort oData once before it is bound to the list, by executionOrderType and then executionOrderPriority ascending
			  	// a-b < 0, a is sorted before b (no change)
			  	// a-b = 0, no change
			  	// a-b > 0, b is sorted before a (change)
		  		oData.items.sort(function(a, b){

		  		    var equalOrderType = a.executionOrderType - b.executionOrderType;
		  		    if (equalOrderType == 0) {
		  		    	return a.executionOrderPriority - b.executionOrderPriority
		  		    }
		  		    return equalOrderType;
		  			});

		  		// Split the array by executionOrderType
		  		var preRulesData  = {count: 0, start: 0};
		  		var mainRulesData = {count: 0, start: 0};
		  		var postRulesData = {count: 0, start: 0};
		  		var totalRuleCount = oData.items.length;

		  		for(var i=0; i<oData.items.length; i++) {
		  			if (oData.items[i].executionOrderType === -1)      preRulesData.count++;
		  			else if (oData.items[i].executionOrderType ===  0) mainRulesData.count++;
		  			else                                               postRulesData.count++;
		  		};

		  		preRulesData.items  = oData.items.slice(0, preRulesData.count);
		  		mainRulesData.items = oData.items.slice(preRulesData.count, preRulesData.count+mainRulesData.count);
		  		postRulesData.items = oData.items.slice(preRulesData.count+mainRulesData.count, oData.items.length);

		  		preRulesData.limit = preRulesData.count;
		  		mainRulesData.limit = mainRulesData.count;
		  		postRulesData.limit = postRulesData.count;

				var oExtraListItemTemplate = new sas.hc.m.StandardListItem({
		            title: "{_displayName}",
		            description: "{_displayDescription}",
		            enabled: "{isAvailable}",
		            type: sap.m.ListType.Active
		        });
	        	var model = new sap.ui.model.json.JSONModel(preRulesData);
			    model.setSizeLimit(totalRuleCount);
		  	    oExtraList.setModel(model);
			    oExtraList.bindItems({
			        path: "/items",
			        template: oExtraListItemTemplate,
			        templateShareable: false
			    });
			    oExtraLabel.setText(sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.ruleOrderTypeWithCount.fmt.txt', [sas.fscf.rb.getText('rules.rulesPage.rules.order.pre.txt'), preRulesData.count]));

			    mainRulesData.itemList = postRulesData.items;
			    var model2 = new sap.ui.model.json.JSONModel(mainRulesData);
			    model2.setSizeLimit(totalRuleCount);
				oDualSelector.setModel(model2);

                // Store just loaded content for rule type
                _this.storeDataForCurrentRuleType(oExtraList, oDualSelector);

				oDialog.setBusy(false);

			  }).fail(function(oObj,textStatus,errorThrown){
   			  	if (oObj.responseJSON && oObj.responseJSON.message) {
   		  			sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, oObj.responseJSON.message, oDialog.sId);
   			  	} else {
   		  			sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.guidedView.errorSavingRule.txt') + " - " + errorThrown, oDialog.sId);
   			  	}
	   			sap.ui.getCore().byId(_this._oDialog.getLeftButton()).setEnabled(false);

   			  	oDialog.setBusy(false);
		  	  });
	    }
    },

    getRuleTypeOrder: function(ruleTypeName) {
    	var ruleTypeOrder = 0;
	    if  (ruleTypeName === "Authorization") 
	    	ruleTypeOrder = 1;
	    else if (ruleTypeName === "Queue")
	    	ruleTypeOrder = 2;
	    return ruleTypeOrder;
    },
    
    annotateData: function(items) {
    	var _this = this;
    	
  		// set the display strings
  	    for (var i = 0; i < items.length; i++) {
  	    	items[i]._displayName = items[i].name + ", " + items[i].baseRuleId + "." + items[i].revision;
  	    	items[i]._displayDescription = sas.fscf.rb.getText("rules.rulesPage.rules.states." + items[i].state.toLowerCase() + ".txt");
   			items[i]._displayDescription += ", " + items[i].transactionTypeDisplayName;
   			if (items[i].transactionTypeAcronym) {
   				items[i]._displayDescription += " (" + items[i].transactionTypeAcronym + ")";
   			}
  	    	items[i].isAvailable = (items[i].state == "Coding");
  	    	items[i].ruleDependencies = items[i].strongRuleDependencies;
  	    	items[i].ruleTypeOrder = _this.getRuleTypeOrder(items[i].ruleTypeName);
  	    	if (items[i].ruleDependencies) {
  	    	   for (var j=0; j < items[i].ruleDependencies.length; j++) {
  	    	      items[i].ruleDependencies[j].rule.ruleTypeOrder = _this.getRuleTypeOrder(items[i].ruleDependencies[j].rule.ruleTypeName);	
  	    	   }
  	    	}
  	    }
    },

    storeDataForCurrentRuleType: function(oExtraList, oDualSelector) {
    	if (this._currentRuleType) {
    	    this._oData[this._currentRuleType].Pre = oExtraList.getModel().getData();
    	    this._oData[this._currentRuleType].MainPost = oDualSelector.getModel().getData();
    	}
    },

    save: function(oDialog, oExtraList, oDualSelector) {
    	var _this = this;
    	oDialog.setBusy(true);

    	// delay to make sure dialog busy indicator renders before doing the work to save
        setTimeout(function () {
        	_this.saveContinue(oDialog, oExtraList, oDualSelector);
        }, 2000);
    },

    validatePreOrder: function(ruleType, idsBefore) {
		// Manually Ordered Pre-Rules
    	var _this = this;
		if (_this._oData[ruleType].Pre) {
			if (_this._oData[ruleType].Pre.items) {
				// For all rules of this type
				for (var i = 0; i < _this._oData[ruleType].Pre.items.length; i++) {
					idsBefore.push(_this._oData[ruleType].Pre.items[i]["id"]);

					// If this rule is in coding and hence may have changed its order, then check that all the rules who
					// need this rule are still in front of this rule.
					if (_this._oData[ruleType].Pre.items[i].isAvailable) {
						// only dependency check the Coding ones
						var anyDependencyAfter = _this.anyDependencyAfter(_this._oData[ruleType].Pre.items[i], idsBefore);
						if (anyDependencyAfter != 0) {
				   		  	sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.dependencyOutOfOrder.fmt.txt', [anyDependencyAfter, _this._oData[ruleType].Pre.items[i]["baseRuleId"]]), _this._oDialog.sId);
			   				return -1;
						}
					}
				}
			}
		}
		return 0;
    },

    // Main rules - Validate that the rules needed by main rules have not been moved to post rules
    validateMainDependencies: function(ruleType, idsBefore) {
    	var _this = this;
    	if (_this._oData[ruleType].MainPost) {
			if (_this._oData[ruleType].MainPost.items) {
				// Push all of the main ids at once onto idsBefore since all of the main rules have equal priority of 0
				for (var i = 0; i < _this._oData[ruleType].MainPost.items.length; i++) {
					idsBefore.push(_this._oData[ruleType].MainPost.items[i]["id"]);

					if (_this._oData[ruleType].MainPost.items[i].isAvailable) {
						var idsInPost =	_this.getIdsInPost(ruleType);
						var anyDependencyinPost = _this.anyDependencyIn(_this._oData[ruleType].MainPost.items[i], idsInPost);
						if (anyDependencyinPost != 0) {
   		  					sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.dependencyOutOfOrder.fmt.txt', [anyDependencyinPost, _this._oData[ruleType].MainPost.items[i]["baseRuleId"]]),  _this._oDialog.sId);
	   	   			    	sap.ui.getCore().byId(_this._oDialog.getLeftButton()).setEnabled(true);
   							return -1;
						}
					}
				}
			}
		}
    },

    validatePostOrder: function(ruleType, idsBefore) {
    	// Manually Ordered Post-Rules
    	var _this = this;
    	if (_this._oData[ruleType].MainPost) {
    		if (_this._oData[ruleType].MainPost.itemList) {
    			for (var i = 0; i < _this._oData[ruleType].MainPost.itemList.length; i++) {
    				idsBefore.push(_this._oData[ruleType].MainPost.itemList[i]["id"]);
    				if (_this._oData[ruleType].MainPost.itemList[i].isAvailable) {
    					// 	only dependency check the Coding ones
    					var anyDependencyAfter = _this.anyDependencyAfter(_this._oData[ruleType].MainPost.itemList[i], idsBefore);
    					if (anyDependencyAfter != 0) {
    						sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.rules.prioritize.dependencyOutOfOrder.fmt.txt', [anyDependencyAfter, _this._oData[ruleType].MainPost.itemList[i]["baseRuleId"]]),  _this._oDialog.sId);
	   	   			    	sap.ui.getCore().byId(_this._oDialog.getLeftButton()).setEnabled(true);
	   	   			    	return -1;
    					}
    				}
    			}
    		}
    	}
    	return 0;
    },

    getIdsInPost: function(ruleType) {
		var _this = this;
    	var idsInPost = [];
    	if (_this._oData[ruleType].MainPost) {
    		if (_this._oData[ruleType].MainPost.itemList) {
    			for (var i = 0; i < _this._oData[ruleType].MainPost.itemList.length; i++) {
    				idsInPost.push(_this._oData[ruleType].MainPost.itemList[i]["id"]);
    			}
    		}
    	}
    	return idsInPost;
    },

    validateOrder: function(ruleType) {
    	var _this = this;
		var idsBefore = [];

		if (_this.validatePreOrder(ruleType, idsBefore) != 0)
			return -1;

		if (_this.validateMainDependencies(ruleType, idsBefore))
			return -1;

		if (_this.validatePostOrder(ruleType, idsBefore) != 0)
			return -1;

		sas.fscf.removeAllMessageStrips();
		return 0;
    },

    saveContinue: function(oDialog, oExtraList, oDualSelector) {
    	var _this = this;

    	// store the data of the current rule type
    	_this.storeDataForCurrentRuleType(oExtraList, oDualSelector);

		var jsonData = [];

		// For each Rule Type: Variable, Authorization, Queue
		for (var ruleType in _this._oData) {

			if (!(_this.validateOrder(ruleType) == 0)) {
				sap.ui.getCore().byId(_this._oDialog.getLeftButton()).setEnabled(true);
   				oDialog.setBusy(false);
   				return;
			}


			// Manually Ordered Pre-Rules
			if (_this._oData[ruleType].Pre) {
				if (_this._oData[ruleType].Pre.items) {
					// For all rules of this type
					for (var i = 0; i < _this._oData[ruleType].Pre.items.length; i++) {
						if (_this.isDirtyForRuleType(ruleType)) {
							// only save the ones that have changed
							if (_this._oData[ruleType].Pre.items[i]["executionOrderType"] != -1 || _this._oData[ruleType].Pre.items[i]["executionOrderPriority"] != i) {
								jsonData.push({id: _this._oData[ruleType].Pre.items[i]["id"], executionOrderType: -1, executionOrderPriority: i});
								}
							} // dirty
						} // each item
					} // has items
				} // there are pre items

			if (_this._oData[ruleType].MainPost) {
				if (_this._oData[ruleType].MainPost.items) {
					for (var i = 0; i < _this._oData[ruleType].MainPost.items.length; i++) {
						if (_this.isDirtyForRuleType(ruleType)) {
							// only save the ones that have changed
							if (_this._oData[ruleType].MainPost.items[i]["executionOrderType"] != 0) {
								jsonData.push({id: _this._oData[ruleType].MainPost.items[i]["id"], executionOrderType: 0, executionOrderPriority: 0});
								}
							} // dirty
						} // for each
					} // has main items

				if (_this._oData[ruleType].MainPost.itemList) {
					for (var i = 0; i < _this._oData[ruleType].MainPost.itemList.length; i++) {
						if (_this.isDirtyForRuleType(ruleType)) {
							// only save the ones that have changed
							if (_this._oData[ruleType].MainPost.itemList[i]["executionOrderType"] != 1 || _this._oData[ruleType].MainPost.itemList[i]["executionOrderPriority"] != i) {
								jsonData.push({id: _this._oData[ruleType].MainPost.itemList[i]["id"], executionOrderType: 1, executionOrderPriority: i});
								}
							} // dirty
						}  // for each
					} // has post items
				} // has main or post items
			} // for each rule type

		if (jsonData.length == 0) {
			oDialog.setBusy(false);
			oDialog.close();
			return;
		}
		sas.ajax({url:"rest/businessunits/" + sas.fscf.getCurrentPageView().getBUId() + "/rules", type: "PUT", data: jsonData, headers:sas.fscf.getAjaxHeaders()})
   		  .done(function(oData){
        	  sas.fscf.getCurrentPageView().getSubView("Rules").updateTable();
   			  oDialog.setBusy(false);
        	  oDialog.close();
   		  }).fail(function(oObj,textStatus,errorThrown){
   			  if (oObj.responseJSON && oObj.responseJSON.message) {
   		  			sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, oObj.responseJSON.message, oDialog.sId);
   			  } else {
   		  			sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.guidedView.errorSavingRule.txt') + " - " + errorThrown, oDialog.sId);
   			  }
   			  sap.ui.getCore().byId(_this._oDialog.getLeftButton()).setEnabled(true);
   			  oDialog.setBusy(false);
		  });
    },

    // Check that this rule is ordered before all rules that need it
    anyDependencyAfter: function(rule, idsBefore) {
    	// returns 0 if no dependency after
    	// returns the rule baseRuleId if dependency after

		if (rule.ruleDependencies) {
			for (var i = 0; i < rule.ruleDependencies.length; i++) {
				if (rule.ruleDependencies[i].dependencyType === "STRONG") {
					if (rule.ruleDependencies[i].rule && rule.ruleDependencies[i].rule.id && 
						rule.ruleDependencies[i].rule.baseRuleId  && rule.ruleDependencies[i].rule.ruleTypeOrder) {		
						if (rule.ruleTypeOrder === rule.ruleDependencies[i].rule.ruleTypeOrder) {
						    if ($.inArray(rule.ruleDependencies[i].rule.id, idsBefore) === -1) {
							    return rule.ruleDependencies[i].rule.baseRuleId;
						    }
						}
					}
				}
			}
		}
		return 0;
    },

    anyDependencyIn: function(rule, ids) {
		if (rule.ruleDependencies) {
			for (var i = 0; i < rule.ruleDependencies.length; i++) {
				if (rule.ruleDependencies[i].dependencyType === "STRONG") {
					if (rule.ruleDependencies[i].rule && rule.ruleDependencies[i].rule.id && 
						rule.ruleDependencies[i].rule.baseRuleId && rule.ruleDependencies[i].rule.ruleTypeOrder) {
						if (rule.ruleTypeOrder === rule.ruleDependencies[i].rule.ruleTypeOrder) {
						    if (!($.inArray(rule.ruleDependencies[i].rule.id, ids) === -1)) {
							    return rule.ruleDependencies[i].rule.baseRuleId;
						    }
						}
					}
				}
			}
		}
		return 0;
    }

});
