sap.ui.jsfragment("sas.fscf.views.fragments.RulePropertiesDialog", {

    ruleNameLabel: null,
	ruleNameText: null,
	transactionTypeLabel: null,
	transactionTypeComboBox: null,
	transactionScopeLabel: null,
	transactionScopeSelect: null,
	transactionScopeText: null,
	ruleDescriptionLabel:null,
	ruleDescriptionText:null,
	operationalTimeLimitLabel:null,
	operationalTimeLimitText:null,
	microsecondsLabel:null,
	businessUnitLabel: null,
	businessUnitText: null,
	ruleTypeSelect:null,
	ruleTypeLabel:null,
	ruleTypeText:null,
	ruleDependenciesText:null,
	ruleVariablesText:null,
	
	_bValidate: false,
    _bEditMode: false,
    _bCodingApproach:false,
    _bRefreshDecisions:false,
	
    createContent: function(oController) {
		
	},

    isValidate: function() {
	    return this._bValidate;
	},
    setValidate: function(bValidate) {
	    this._bValidate = bValidate;
	},
	isCodingApproach: function() {
    	return this._bCodingApproach;
    },

    setCodingApproach: function(bCodingApproach) {
    	this._bCodingApproach = bCodingApproach;
    },


	lazyLoadContent: function() {
		var _this = this;
		_this._bEditMode = sas.fscf.getCurrentPageView().jsonRule != null;
		
		var approach=_this.isCodingApproach() ? sas.fscf.rb.getText('rules.rulesListDetailMenu.codingApproach.txt') : sas.fscf.rb.getText('rules.rulesListDetailMenu.guidedApproach.txt');
		var title=sas.fscf.rb.getText('rules.rulesListDetailMenu.newRule.txt')+" (" +approach+")";
        var oDialog = new sas.hc.m.Dialog({
        	id: "RulePropertiesDialog",
        	title: _this._bEditMode ?  sas.fscf.rb.getText('rules.rulesPage.properties.txt') : title,
    	    content: [
    	              _this._bEditMode ? _this.getTabs() : _this.getGrid()
	    	    ],
	    	    leftButton: new sas.hc.m.Button({
	    	    	text: (_this._bEditMode) ? sas.fscf.rb.getText('rules.rulesPage.guidedView.save.txt') : sas.fscf.rb.getText('rules.rulesPage.next.txt'),
	    	        enabled: (_this._bEditMode) ? false : true,
	    	    	press: function() {
	    	        	var _leftButton = this;
	    	        	_leftButton.setEnabled(false);
	    	        	if(ruleNameText.getValue().trim()==""){
	    	        		ruleNameText.setValueState(sap.ui.core.ValueState.Error);
	    	        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.guidedView.form.emptyField.error.txt"));
	    	        		_leftButton.setEnabled(true);
	    	        		return;
	    	        	}
	    	        	if(!_this._bEditMode){
		    	        	if(transactionTypeComboBox.getSelectedKey()==""){
		    	        		transactionTypeComboBox.setValueState(sap.ui.core.ValueState.Error);
		    	        		_leftButton.setEnabled(true);
		    	        		return;
		    	        	}
	    	        	}
	    	        	var ruleId = _this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.id : "";
	    	        	var urlString = "";
	    	        	var requestType = "";
	    	        	var jsonRule = null;
	    	        	
	    	        	if (!_this._bEditMode) {//new rule
	    	        		urlString = 'rest/businessunits/' + sas.fscf.getCurrentPageView().getBUId() + '/rules/';
	    	        		requestType = "POST";
	    	        		if(_this.isCodingApproach()){//Coding rule
		    	        	    jsonRule = {
		    	        	      	"id":ruleId,
		    	        			"name":ruleNameText.getValue(),
		    	        			"transactionTypeId":transactionTypeComboBox.getSelectedKey(),
		    	        			"multiOrgNodeId":transactionScopeSelect.getSelectedKey(),
		    	        			"description":ruleDescriptionText.getValue(),
		    	        			//"operationalTimeLimit":operationalTimeLimitText.getValue(),
		    	        			"ruleTypeName":ruleTypeSelect.getSelectedKey(),//TODO
		    	        			"businessUnitId":sas.fscf.getCurrentPageView().getBUId(),   
		    	        			"queueId":"",
		    	        			"alertTypeId":"",
		    	        			"alertReason":"",
		    	        			"guidedRule":false
		    	        		};
	    	        		}else{//guided rule
	    	        			jsonRule = {
	    	  	        		      "id":ruleId,
	    	  		        		  "name":ruleNameText.getValue(),
	    	  		        		  "transactionTypeId":transactionTypeComboBox.getSelectedKey(),
	    	  		        		  "multiOrgNodeId":transactionScopeSelect.getSelectedKey(),
	    	  		        		  "description":ruleDescriptionText.getValue(),
	    	  		        		  //"operationalTimeLimit":operationalTimeLimitText.getValue(),
	    	  		        		  "ruleTypeName":"Authorization",
	    	  		        		  "businessUnitId":sas.fscf.getCurrentPageView().getBUId(),
	    	  		        		  "guidedRule":true
	    	  		        	};
	    	        		}
	    	        	}else {//editing existing rule
	    	        		urlString = 'rest/businessunits/' + sas.fscf.getCurrentPageView().getBUId() + '/rules/'+ruleId;
	    	        		requestType = "PUT";
	    	        		if(_this.isCodingApproach()){//coding
		    	        		jsonRule = sas.fscf.getCurrentPageView().jsonRule;
		    	        		jsonRule["name"] = ruleNameText.getValue();
		    	        		jsonRule["transactionTypeId"] = transactionTypeComboBox.getSelectedKey();
		    	        		jsonRule["multiOrgNodeId"] = transactionScopeSelect.getSelectedKey();
		    	        		jsonRule["description"] = ruleDescriptionText.getValue();  
		    	        		jsonRule["operationalTimeLimit"] =operationalTimeLimitText.getValue();
		    	        		jsonRule["expressions"]=null;
		    					jsonRule["guidedRule"]= false;
	    	        		}else{//guided
	    	        			jsonRule = sas.fscf.getCurrentPageView().jsonRule;	    	        			
	    	        			jsonRule["name"] = ruleNameText.getValue();
	    	        			jsonRule["transactionTypeId"] = transactionTypeComboBox.getSelectedKey();
	    	        			jsonRule["multiOrgNodeId"] = transactionScopeSelect.getSelectedKey();
	    	        			jsonRule["description"] = ruleDescriptionText.getValue();
	    	        			jsonRule["operationalTimeLimit"] =operationalTimeLimitText.getValue();
	    	        			jsonRule["ruleTypeName"] = "Authorization";
		    					jsonRule["guidedRule"]= true;
	    	        			
	    	        		}
	    	        	}
	    	        	
	    	        	sas.ajax({url:urlString, type: requestType, data: jsonRule, headers:sas.fscf.getAjaxHeaders()})
	    	        	  .done(function(oData){
	    	        		jsonRule.lastUpdateNumber = oData.lastUpdateNumber;
	    	        		
	    	        		if (_this._bEditMode) {
			        			var fields = "expressions";
			        			if (sas.fscf.ruleApproach == sas.fscf.RULE_APPROACH_CODING) {
			        				fields += ",ruleCode";
			        			}
			        			// get the rule's expressions and code
			        			sas.ajax({url:'rest/businessunits/'+jsonRule.businessUnitId+'/rules/'+jsonRule.id+'?fields='+fields, headers:sas.fscf.getAjaxHeaders()})
			        			  .done(function(oData){
			        			    var expressions = oData.expressions;
			        			    if (expressions) {
			        			    	jsonRule.expressions = expressions;
			        			    } else {
			        			    	jsonRule.expressions = sas.fscf.getEmptyRuleExpressions();
			        			    }
			        			    var ruleCode = oData.ruleCode;
			        			    if (ruleCode) {
			        			    	jsonRule.ruleCode = ruleCode;
			        			    } else {
			        			    	jsonRule.ruleCode = "";
			        			    }
			        			    jsonRule.businessUnitName = sas.fscf.getCurrentPageView().getBUName();
			        			    _this.finishNext(jsonRule, oDialog);
			        			}).fail(function(oObj,textStatus){
			        			     console.log("failure getting rule's expressions and code");
			        			     jsonRule.ruleCode = "";
				        			 _this.finishNext(jsonRule, oDialog);
			        			});
			        		}else{//new rule (coding or guided)
	    	        			jsonRule.id=oData.id;
	    	        			jsonRule.expressions = sas.fscf.getEmptyRuleExpressions();
	    	        			jsonRule.businessUnitName = sas.fscf.getCurrentPageView().getBUName();
	    	        			_this.finishNext(jsonRule, oDialog);
	    	        	    }
	    	        		//reload auto-completer with new transaction type
	    	        		sas.fscf.getCurrentPageView().jsonRule["transactionTypeId"]=jsonRule["transactionTypeId"];
		    	        	if (sas.fscf.ruleApproach === sas.fscf.RULE_APPROACH_CODING) {
		    	        		sap.ui.getCore().byId("RulesPageCodingView").setQueuedResponseMacros();
		    	        		sap.ui.getCore().byId("RulesPageCodingView").setAlwaysDisable();
		    	        		sap.ui.getCore().byId("RulesPageCodingView").loadAutoCompleter(sap.ui.getCore().byId("RulesPageCodingViewCustomCodeEditor"));
		    	        		sap.ui.getCore().byId("RulesPageCodingView").setVerified(false);
		    	        		sap.ui.getCore().byId("RulesPageCodingView").remoteSyntaxCheck(sap.ui.getCore().byId("RulesPageCodingViewCustomCodeEditor"),false);
	    	        	 	}
	    	        	 }).fail(function(oObj,textStatus,errorThrown){
	    	        		 if(errorThrown == "Conflict"){
	    	        			 sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.guidedView.cannotEditEditedElsewhere.txt'), oDialog.sId);
	    	        		 } else if (oObj.responseJSON && oObj.responseJSON.message) {
	    	        			 sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, oObj.responseJSON.message, oDialog.sId);
	    	        		 } else {
	    	        			 sas.fscf.showMessageStrip(sap.ui.core.MessageType.Error, sas.fscf.rb.getText('rules.rulesPage.guidedView.errorSavingRule.txt'), oDialog.sId);
	    	        		 }
	    	        		 _leftButton.setEnabled(true);
	    	        	});
	    	        }	
	    	    }),
	    	    rightButton:  new sas.hc.m.Button({
	    	    	text: sas.fscf.rb.getText('rules.rulesPage.cancel.txt'),
	    	        press: function() {
	    	        	oDialog.close();
	    	        }
	    	    })
	        });
	        ruleNameText.attachBrowserEvent("keydown", function(e) { //use keydown so backspace and delete work       	
	        	if(_this._bEditMode){//enable save button
					_this.enableSaveButton(true);
				}
	        });
	        ruleNameText.attachBrowserEvent("keypress", function(e) {
	        	
	        	var key_codes = [35,37,38,44,60,62];
				if ($.inArray(e.which, key_codes) >= 0) {
					e.preventDefault();
					ruleNameText.setValueState(sap.ui.core.ValueState.Error);
	        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.specialCharacters.error.txt"));
				}
	        });
	
	        ruleNameText.attachBrowserEvent("paste", function(e) {
	        	// RAPTOR-2399 window.clipboardData supported by IE only.
	        	var text = (window.clipboardData) ? window.clipboardData.getData('text') : "";
	        	if(text.indexOf("#") != -1 || text.indexOf("%") != -1 || text.indexOf("&") != -1 || text.indexOf("<") != -1 || text.indexOf(">") != -1 || text.indexOf(",") != -1){
	        		e.preventDefault();
	        		ruleNameText.setValueState(sap.ui.core.ValueState.Error);
	        		ruleNameText.setValueStateText(sas.fscf.rb.getText("rules.rulesPage.specialCharacters.error.txt"));
	        	}
	        });
	        	
	        oDialog.attachAfterClose(function(oEvent) {
	        	this.ruleNameLabel= null;
	        	this.ruleNameText= null;
	        	this.transactionTypeLabel= null;
	        	this.transactionTypeComboBox= null;
	        	this.transactionTypeText=null;
	        	this.transactionScopeLabel= null;
	        	this.transactionScopeSelect= null;
	        	this.ruleDescriptionLabel=null;
	        	this.ruleDescriptionText=null;
	        	this.operationalTimeLimitLabel=null;
	        	this.operationalTimeLimitText=null;
	        	this.microsecondsLabel=null;
	        	this.businessUnitLabel= null;
	        	this.businessUnitText= null;
	        	this.ruleTypeSelect=null;
	        	this.ruleTypeText=null;
	        	this.ruleTypeLabel=null;
	        	this.ruleDependenciesText=null;
	        	this.ruleVariablesText=null;
	        	this.destroy();
	        });

        return oDialog;
    },//end lazy loading
    
    finishNext: function(jsonRule, oDialog) {
  		sas.fscf.getCurrentPageView().jsonRule = jsonRule;
  		
    	if(!this._bEditMode){//new rule
    		if(this.isCodingApproach()){//coding
    			sas.fscf.getCurrentPageView().switchToCodingContent();
    		}else{//guided    			
    			sas.fscf.getCurrentPageView().switchToGuidedContent(); 
    		}	
    	}else{//editing a rule
    		if(!this.isCodingApproach()){//editing a guided rule
    			if(sap.ui.getCore().byId("RulesPageGuidedViewToolbarRuleNameLabel"))
    				sap.ui.getCore().byId("RulesPageGuidedViewToolbarRuleNameLabel").setText("> " + jsonRule.name);
    			
    			if(this._bRefreshDecisions){//refresh decisions to reflect new tran type
    				sap.ui.getCore().byId("RulesPageGuidedViewActionsViewalertActionCheckBox").setEnabled(true);
    				sap.ui.getCore().byId("RulesPageGuidedViewActionsView").getDecisionSelect(true);
    				sap.ui.getCore().byId("RulesPageGuidedViewActionsView").setIgnoreState(false);
    			}
    		}else{
    			if(sap.ui.getCore().byId("RulesPageCodingViewToolbarRuleNameLabel"))
    				sap.ui.getCore().byId("RulesPageCodingViewToolbarRuleNameLabel").setText("> " + jsonRule.name);
    		}
    	}	 	
    	oDialog.close();
    },
    getTransactionScopeSelect: function(buId){
    	var _this=this;
    	var transactionScopeModel = new sap.ui.model.json.JSONModel("rest/multiorgs?businessUnit="+buId);
    	transactionScopeModel.setSizeLimit(100000);    	
    	transactionScopeSelect = new sas.hc.m.Select({
    		selectedKey : this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.multiOrgNodeId : "",
    		width : "400px",
    		layoutData : new sas.hc.ui.layout.GridData({
				span : "L8 M8 S8"
    		})
    	});
    	transactionScopeSelect.bindAggregation("items", "/items", new sas.hc.ui.core.ListItem({key:"{id}",text:"{displayName}"}));
    	transactionScopeSelect.setModel(transactionScopeModel);
    	transactionScopeSelect.attachChange(function (oEvent) {    		
			if(_this._bEditMode)
				_this.enableSaveButton(true);
        }); 
    	return transactionScopeSelect;
    },

    getTransactionTypeComboBox: function(buId){
    	var _this=this;
//    	if(!_this._bEditMode){
	    	jQuery.sap.require("sap.ui.model.Sorter");
	    	let stock = "";
	    	if (!this.isCodingApproach()) {
	    		stock = "?type=stock";
	    	}
	    	var transactionTypesModel = new sap.ui.model.json.JSONModel("rest/businessunits/"+buId+"/transactiontypes"+stock);
	    	transactionTypesModel.setSizeLimit(100000);    	
	    	transactionTypeComboBox = new sas.hc.m.ComboBox({
	    		selectedKey : this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.transactionTypeId : "",
				width : "400px",
	    		layoutData : new sas.hc.ui.layout.GridData({
					span : "L8 M8 S8",
					width: "100rem"
	    		})
	    	});    	
	    	
	    	// control is missing getSelectedItem function, so add it
	    	transactionTypeComboBox.getSelectedItem = function() {
	    		return sap.ui.getCore().byId(this.getSelectedItemId());
	    	};
	    	transactionTypeComboBox.bindAggregation("items", {
	            path: "/items",
	            factory: function(sId, oContext) {
	                  return new sas.hc.ui.core.ListItem(sId, {
	                        key: oContext.getProperty("id"),
	                        text: oContext.getProperty("displayName")
	                  });
	            },
	            sorter: new sap.ui.model.Sorter("description")
	        });
	
	    	transactionTypeComboBox.setModel(transactionTypesModel);	
	    	transactionTypeComboBox.attachChange(function (oEvent) {
	    		transactionTypeComboBox.setValueState(sap.ui.core.ValueState.None);
				if(_this._bEditMode){//enable save button
					_this.enableSaveButton(true);
					_this._bRefreshDecisions=true;
				}
	        });  	    	
	    	return transactionTypeComboBox;
//    	}else{
//    		transactionTypeText = new sas.hc.m.Text({
//					text: "",
//					layoutData : new sas.hc.ui.layout.GridData({
//		    			span : "L8 M8 S8"
//		    		})
//		    });
//    		sas.ajax({url:"rest/businessunits/"+buId+"/transactiontypes?type=stock", headers:sas.fscf.getAjaxHeaders()})
//  		    .done(function(oData){
//  		    	for(i=0;i<oData.items.length;i++){
//  		    		if (oData.items[i].id==sas.fscf.getCurrentPageView().jsonRule.transactionTypeId){
//  		    			transactionTypeText.setText(oData.items[i].displayName);
//  		    			break 		    			
//  		    		}
//  		    	}  	    	
//  		    	
//  		    }).fail(function(oObj,textStatus){
//  		         console.info("Failed to get transaction types. ");
//  			 });
//    		return transactionTypeText; 
//    	}
    },
  
    getRuleTypeLabel: function(){
    	if(this.isCodingApproach()){
    		ruleTypeLabel = new sas.hc.m.Label({
				id: this.sId + "RuleTypeLabel",
				text: sas.fscf.rb.getText('rules.rulesPage.ruleType.txt'),
				required:true,
				layoutData : new sas.hc.ui.layout.GridData({
					linebreakL: true,
						linebreakM: true,
						linebreakS: true,
					span : "L4 M4 S4"
				})
			});
    		return ruleTypeLabel;
    	}else return null;
    	
    },
    
    getRuleTypeSelect: function(){
    	if(this.isCodingApproach()){
	    	if(!this._bEditMode){//can only edit if new rule
		    	ruleTypeSelect = new sas.hc.m.Select({
		    		selectedKey : this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.ruleTypeName : "Authorization",
		    		width : "400px",
		    		layoutData : new sas.hc.ui.layout.GridData({
		    			span : "L8 M8 S8"
		    		})
		    	});
		    	ruleTypeSelect.insertItem(new sas.hc.ui.core.Item({key: "Authorization",text: sas.fscf.rb.getText("rules.rulesPage.authorization.txt"),}),0);
		    	ruleTypeSelect.insertItem(new sas.hc.ui.core.Item({key: "Variable",text: sas.fscf.rb.getText("rules.rulesPage.variable.txt"),}),0);
		    	ruleTypeSelect.insertItem(new sas.hc.ui.core.Item({key: "Queue",text: sas.fscf.rb.getText("rules.rulesPage.queue.txt"),}),0);
		    	return ruleTypeSelect;
	    	}else{
	    		ruleTypeText = new sas.hc.m.Text({
						text: sas.fscf.getCurrentPageView().jsonRule.ruleTypeName
				});
	    		return ruleTypeText;
	    	}
    	}else return null;
    },
    enableSaveButton: function(enable){
    	sap.ui.getCore().byId(sap.ui.getCore().byId("RulePropertiesDialog").getLeftButton()).setEnabled(enable);
    },
    getRuleDependenciesLabel:function(){
    	var _this = this;
    	if(_this._bEditMode){
	    	ruleDependenciesLabel = new sas.hc.m.Label({
					id: _this.sId + "ruleDependenciesLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.dependencies.txt')+":",
					required:false,
					layoutData : new sas.hc.ui.layout.GridData({
						linebreakL: true,
						linebreakM: true,
						linebreakS: true,
						span : "L3 M3 S3"
					})
			});
	    	return ruleDependenciesLabel;
    	}
    },

    getRuleDependencies: function(ruleDependencies){
    	var _this = this;
    	if(_this._bEditMode){
	    	ruleDependenciesText = new sas.hc.m.Text({
		  			text:  "",
		    		layoutData : new sas.hc.ui.layout.GridData({
		    			span : "L9 M9 S9"
		    		}),
		    		wrapping:true
		  	});
	    	ruleDependenciesText.onAfterRendering = function () {  
	        	//this.$().css({'line-height':'1rem !important'});
	        	$(this.getDomRef()).css('line-height','1rem !important');
	        };
	    	
	  	  	var ruleDependenciesStr="";
	  	  	if(ruleDependencies!=null){
		  		for (var i = 0; i <ruleDependencies.length; i++){
		  			var ruleTypeName = ruleDependencies[i].rule.ruleTypeName == null ? "null" : ruleDependencies[i].rule.ruleTypeName;
		  			if(ruleDependencies[i].dependencyType=="STRONG"){		  				
		  				var maxLength=5;
		  				var baseRuleIdZeroPad="00000".substring(0, maxLength -ruleDependencies[i].rule.baseRuleId.length) + ruleDependencies[i].rule.baseRuleId;
			          	var name = ruleDependencies[i].rule.name == null ? "null" : ruleDependencies[i].rule.name;
			           	var state= ruleDependencies[i].rule.state;
			           	var value= "#" + ruleTypeName.substring(0, 1) + baseRuleIdZeroPad + ": "
			                   + name.replace(/\"/g, "''").replace(/\\\\/g, "/") + " - " + state +" ("+ sas.fscf.rb.getText('rules.rulesPage.ruleProperties.for.txt') +" %hasRuleFired)";
		  				ruleDependenciesStr+=value+"\r\n";
		  			}else{
		  			   var version =ruleDependencies[i].version;
		  			   if(version==null || ""){
		  					ruleDependenciesStr+=sas.fscf.rb.getText('rules.rulesPage.ruleProperties.rule.txt')+ ruleDependencies[i].baseRuleId+"."+ruleDependencies[i].version+"\r\n";
		  			    }else{
		  					ruleDependenciesStr+="#"+ ruleTypeName.substring(0, 1)+ ruleDependencies[i].rule.baseRuleId+": "+ruleDependencies[i].rule.name+" - "+ruleDependencies[i].rule.state+" ("+sas.fscf.rb.getText('rules.rulesPage.ruleProperties.sets.txt')+" "+ ruleDependencies[i].rule.keywords.toUpperCase()+")\r\n";
		  			    	
		  				}
		  			}
		  	  	}		  	  	
		  	  	ruleDependenciesText.setText(ruleDependenciesStr);
	  	  	}else{	  	  	
	  	  		ruleDependenciesText.setText(sas.fscf.rb.getText('fcm.application.none.txt'));
	  	  	}	  	   
	    	return ruleDependenciesText;  
    	}
    },
    getRuleVariablesLabel:function(){
    	var _this = this;
    	if(_this._bEditMode){
	    	ruleVariablesLabel = new sas.hc.m.Label({
					id: _this.sId + "ruleVariablesLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.variables.txt')+":",
					required:false,
					layoutData : new sas.hc.ui.layout.GridData({
						linebreakL: true,
						linebreakM: true,
						linebreakS: true,
						span : "L3 M3 S3"
					})
			});
	    	return ruleVariablesLabel;
    	}
    },
    getRuleVariables: function(ruleVariables){
    	var _this = this;
    	if(_this._bEditMode){
	    	ruleVariablesText = new sas.hc.m.Text({
	  			text:  "",
	    		layoutData : new sas.hc.ui.layout.GridData({
	    			span : "L9 M9 S9"
	    		})
	    	});
	    	var ruleVariablesStr="";
	    	if(ruleVariables!=null){
	    	for(var i=0;i<ruleVariables.length;i++){
	    		ruleVariablesStr+=ruleVariables[i].altName;
	    		if(i<ruleVariables.length-1)
	    			ruleVariablesStr+=", ";
	    	}
	    	}
	    	ruleVariablesText.setText(ruleVariablesStr);
	    	return ruleVariablesText;
    	}
    },
    getGrid:function(){
    	var _this=this;
    	return new sas.hc.ui.layout.Grid({
				hSpacing: 1,
				vSpacing: 1,
			    width: "650px",
				content: [
				          _this.getRuleTypeLabel(),//only for coding approach
				          _this.getRuleTypeSelect(),//only for coding approach
				          ruleNameLabel = new sas.hc.m.Label({
								id: _this.sId + "ruleNameLabel",
								text: sas.fscf.rb.getText('rules.rulesPage.name.txt'),
								required:true,
								layoutData : new sas.hc.ui.layout.GridData({
									linebreakL: true,
									linebreakM: true,
									linebreakS: true,
									span : "L4 M4 S4"
								})
				          }),
				          ruleNameText = new sas.hc.m.Input({
							 	id: _this.sId + "RuleNameText",
							 	value: _this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.name : "",
							 	required:true,
								width:"400px",
								layoutData : new sas.hc.ui.layout.GridData({
									span : "L8 M8 S8"
								})
				          }),				
				          transactionTypeLabel = new sas.hc.m.Label({
								id: _this.sId + "transactionTypeLabel",
								text: sas.fscf.rb.getText('rules.rulesPage.transactionType.txt'),
								required:!_this._bEditMode ? true : false,
								layoutData : new sap.ui.layout.GridData({
									linebreakL: true,
									linebreakM: true,
									linebreakS: true,
									span : "L4 M4 S4"
								})
				          }),
				_this.getTransactionTypeComboBox(sas.fscf.getCurrentPageView().getBUId()),
				transactionScopeLabel = new sas.hc.m.Label({
					id: _this.sId + "transactionScopeLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.transactionScope.txt'),
					required:true,
					layoutData : new sap.ui.layout.GridData({
					    linebreakL: true,
						linebreakM: true,
						linebreakS: true,
						span : "L4 M4 S4"
					})
				}),
				_this.getTransactionScopeSelect(sas.fscf.getCurrentPageView().getBUId()),
				businessUnitLabel = new sas.hc.m.Label({
				    id: _this.sId + "businessUnitLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.businessUnit.txt'),
					layoutData : new sas.hc.ui.layout.GridData({
						linebreakL: true,
						linebreakM: true,
						linebreakS: true,
						span : "L4 M4 S4"
					})
				}),
				businessUnitText = new sas.hc.m.Text({
					text: sas.fscf.getCurrentPageView().getBUName()
			    }),
			    _this.getOperationalTimeLimitLabel(),
			    _this.getOperationalTimeLimitText(),
			    _this.getMicrosecondsLabel(),
			    
				ruleDescriptionLabel = new sas.hc.m.Label({
					id: _this.sId + "RuleDescriptionLabel",
					text: sas.fscf.rb.getText('rules.rulesPage.description.txt'),
					layoutData : new sap.ui.layout.GridData({
						linebreakL: true,
						linebreakM: true,
						linebreakS: true,
						span : "L4 M4 S4"
					})
				}),
				ruleDescriptionText = new sas.hc.m.TextArea({
				 	id: _this.sId + "RuleDescriptionText",
				 	value: _this._bEditMode ? sas.fscf.getCurrentPageView().jsonRule.description : "",
					width:"400px",
					rows:3,
					maxLength:300,
					layoutData : new sas.hc.ui.layout.GridData({
						span : "L8 M8 S8"
					})
				}),
				ruleDescriptionText.attachBrowserEvent("keydown", function(e){
					if(_this._bEditMode){
						_this.enableSaveButton(true);
					}
				})
				
	  		    ]
          });
    },
    getDependencies:function(){
    	var _this=this;
    	var gridDependencies= new sas.hc.ui.layout.Grid({
			hSpacing: 1,
			vSpacing: 1,
		    width: "650px"
    	});

    	var urlString="rest/businessunits/"+sas.fscf.getCurrentPageView().getBUId()+"/rules?filter=(id=="+sas.fscf.getCurrentPageView().jsonRule.id+")&fields=id,name,baseRuleId,ruleTypeName,keywords,ruleVariables,ruleDependencies,state";
		sas.ajax({url:urlString, headers:sas.fscf.getAjaxHeaders()}).done(function(oData){
			if(oData.items[0].ruleDependencies!=null || oData.items[0].ruleVariables!=null){
			gridDependencies.addContent(_this.getRuleDependenciesLabel());
			gridDependencies.addContent(_this.getRuleDependencies(oData.items[0].ruleDependencies));
			gridDependencies.addContent(_this.getRuleVariablesLabel());
			gridDependencies.addContent(_this.getRuleVariables(oData.items[0].ruleVariables));
			sap.ui.getCore().byId("RuleDependenciesTab").setEnabled(true);
			}
	  }).fail(function(oObj,textStatus){
			console.log("failure getting rule's dependencies");
	  });
	  return gridDependencies; 
    },
    getOperationalTimeLimitLabel:function(){
    	var _this=this;
    	if(_this._bEditMode){
	    	operationalTimeLimitLabel= new sas.hc.m.Label({
			    id: _this.sId + "OperationalTimeLimitLabel",
				text: sas.fscf.rb.getText('rules.rulesPage.maxExecutionTime.txt'),
				required:false,
				layoutData : new sas.hc.ui.layout.GridData({
					linebreakL: true,
					linebreakM: true,
					linebreakS: true,
					span : "L4 M4 S4"
				})
			});
	    	return operationalTimeLimitLabel;
    	}else return null;
    },
    getOperationalTimeLimitText:function(){
    	var _this=this;
    	if(_this._bEditMode){
    		operationalTimeLimitText= new sas.hc.m.Input({
				id: _this.sId + "OperationalTimeLimitText",
			 	value: sas.fscf.getCurrentPageView().jsonRule.operationalTimeLimit,
			 	type: sap.m.InputType.Number,
			    allowIntegerOnly: true,
			    formatValue: false,
			 	required:false,
				width:"190px",
				layoutData : new sas.hc.ui.layout.GridData({
					span : "L4 M4 S4"
				})
    		});
		 	operationalTimeLimitText.attachBrowserEvent("keydown", function(e){
				_this.enableSaveButton(true);
			});
		 	return operationalTimeLimitText;					    
    	}else return null;
    },
    getMicrosecondsLabel:function(){
    	var _this=this;
    	if(_this._bEditMode){
	    	microsecondsLabel= new sas.hc.m.Label({
			    id: _this.sId + "MicrosecondsLabel",
				text: sas.fscf.rb.getText('rules.rulesPage.microseconds.txt'),
				required:false,
				layoutData : new sas.hc.ui.layout.GridData({
//					linebreakL: true,
//					linebreakM: true,
//					linebreakS: true,
					span : "L4 M4 S4"
				})
			});
	    	return microsecondsLabel;
    	}else return null;
    },
    getTabs:function(){
    	var _this=this;
    	var oRulePropertiesTabBar = new sas.hc.m.IconTabBar({
            id:  _this.sId + "RulePropertiesTabBar",
            firstTabClosable: true,
            showOverflowPopOver: false,
            enableDynamicStyle: true
        });
    	var oPropertiesTab = new sas.hc.m.IconTabFilter("RulePropertiesTab", {
                design: "Horizontal",
                icon: "sap-icon://hc/form",
                iconColor: "Neutral",
                text: sas.fscf.rb.getText('rules.rulesPage.properties.txt'),
                closable: true
        });
    	var oDependenciesTab = new sas.hc.m.IconTabFilter("RuleDependenciesTab", {    		
            design: "Horizontal",
            icon: "sap-icon://hc/allocationRule",
            iconColor: "Neutral",
            text: sas.fscf.rb.getText('rules.rulesPage.rules.print.dependencies.txt'),
            closable: true,
            enabled: false
    	});
    	oPropertiesTab.addContent(_this.getGrid());
    	oDependenciesTab.addContent(_this.getDependencies());
    			
        oRulePropertiesTabBar.addItem(oPropertiesTab);
    	oRulePropertiesTabBar.addItem(oDependenciesTab);
    	
    	return oRulePropertiesTabBar;

    }

});
